# -*- Makefile -*-

CONFIG += debug

TEMPLATE = app
TARGET = kaiman
DEPENDPATH += .
INCLUDEPATH += .
#RESOURCES += kaiman.qrc
QT += core gui opengl
QMAKE_CXXFLAGS += -std=c++11

# For debugging
debug {
	QMAKE_CXXFLAGS += -g -Wall -Werror
	CONFIG += debug
	DEFINES+=USE_DEBUG
}

DEFINES+=VERSION=\\\"0.0.1\\\"

win32 {
	LIBPATH += lua/lib
	INCLUDEPATH += lua/include
	LIBS += -llua51
	DEFINES += HOST_WIN32
#	debug {
		CONFIG += console
#	}
}

unix {
	CONFIG += link_pkgconfig
	packagesExist(lua) {
		PKGCONFIG += lua
	}
	packagesExist(lua5.1) {
		PKGCONFIG += lua5.1
	}
	LIBS += -lao -lsndfile -lsamplerate
}

HEADERS += \
	src/mainwindow.h \
	src/outputwindow.h \
	src/luascript.h \
	src/codeeditor.h \
	src/soundplayer.h \
	src/highlighter.h

SOURCES += \
	src/kaiman.cc \
	src/mainwindow.cc \
	src/outputwindow.cc \
	src/luascript.cc \
	src/codeeditor.cc \
	src/soundplayer.cc \
	src/highlighter.cc

#TRANSLATIONS = pracro_dk.ts
