/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim: set et sw=2 ts=2: */
/***************************************************************************
 *            soundplayer.h
 *
 *  Fri Sep  5 17:31:27 CEST 2014
 *  Copyright 2014 Bent Bisballe Nyeng
 *  deva@aasimon.org
 ****************************************************************************/

/*
 *  This file is part of Kaiman.
 *
 *  Kaiman is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  Kaiman is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Kaiman; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
 */
#pragma once

#include <QThread>
#include <QString>
#include <QList>
#include <QMutex>
#include <QMap>

#include <cstdlib>

class QueueItem
{
public:
	float *samples;
	std::size_t pos;
	std::size_t size;
};

class SoundPlayer
	: public QThread
{
public:
	SoundPlayer();
	~SoundPlayer();

	void playFile(QString file);

	void run();

private:
	volatile bool running;
	QMutex mutex;

	QList<QueueItem> queue;
	QList<QueueItem> active;

	struct Samples
	{
		float *data;
		std::size_t size;
	};
	Samples getSampleData(QString file);
	QMap<QString, Samples> cache;
};
